// -*- C++ -*-
/*!
 * @file  ConsoleIn.cpp
 * @brief Console input component
 * $Date: 2007/04/13 15:03:02 $
 *
 * $Id: ConsoleIn.cpp,v 1.3 2007/04/13 15:03:02 n-ando Exp $
 */

#include "ConsoleIn.h"
#include <iostream>

// Module specification
// <rtc-template block="module_spec">
static const char* consolein_spec[] =
  {
    "implementation_id", "ConsoleIn",
    "type_name",         "ConsoleIn",
    "description",       "Console input component",
    "version",           "1.0",
    "vendor",            "Noriaki Ando, AIST",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

ConsoleIn::ConsoleIn(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    count(0),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

ConsoleIn::~ConsoleIn()
{
}


RTC::ReturnCode_t ConsoleIn::onExecute(RTC::UniqueId ec_id)
{
  TimedLong out;

  std::cout << "Please input number: ";
  std::cin >> out.data;
  std::cout << "Sending to subscriber: " << out.data << std::endl;

  // OutPortɂ閼O
  std::string out_name("out");
  out_name += otos(count); // otos(): StringUtil.h

 // ϐ₷
  m_outv.push_back(out);
  // OutPort ₷
  m_outOutv.push_back(new OutPort<TimedLong>(out_name.c_str(), m_outv.back()));
  // OutPorto^
  registerOutPort(out_name.c_str(), *(m_outOutv.back()));

  for (int i(0), len(m_outv.size()); i < len; ++i)
    {
      m_outv[i] = out;
      m_outOutv[i]->write();
    }

  ++count;
  return RTC::RTC_OK;
}


extern "C"
{
 
  void ConsoleInInit(RTC::Manager* manager)
  {
    RTC::Properties profile(consolein_spec);
    manager->registerFactory(profile,
                             RTC::Create<ConsoleIn>,
                             RTC::Delete<ConsoleIn>);
  }
  
};


